#include "EasyInput.h"

int EI_input_string(char* string, int string_length, int chars_allowed, int column, int row, int input_box_length, int align, int start_mode)
{
	unsigned int key = 0;
	int i = 0, j = 0, tmp = 0;
	int displacement = 0;
	char cursor[] = {0xE6, 0x9A};

	column--;
	row--;
	input_box_length -= 2;

	for(i=0; i<string_length; i++) string[i] = 0;

	if(start_mode == ALPHA_LOCKED)
	{
		KBD_PutKey(KEY_CTRL_SHIFT, 0);
		GetKey(&key);
	}

	if(start_mode >= ALPHA)
	{
		KBD_PutKey(KEY_CTRL_ALPHA, 0);
		GetKey(&key);
		Cursor_SetFlashStyle(2);
	}

	i = 0;

	Cursor_SetFlashMode(1);

	while(key != KEY_CTRL_SHIFT && key != KEY_CTRL_EXIT)
	{
		switch(align)
		{
			case LEFT : Cursor_SetPosition(column, row);
				break;

			case CENTER : Cursor_SetPosition((int)((2 * column + input_box_length - 1) / 2 - EI_str_length(string) / 2), row);
				break;

			case RIGHT : Cursor_SetPosition(column + ((displacement) ? 0 : input_box_length - EI_str_length(string) + 1), row);
				break;
		}

		if(displacement) Print((const unsigned char*)cursor);

		Print((const unsigned char*)(string + displacement));

		GetKey(&key);

		if(i < string_length && (
			(key >= 'a' && key <= 'z' && (chars_allowed & 1)) || 
			(key >= 'A' && key <= 'Z' && (chars_allowed & 2)) ||
			(key >= '0' && key <= '9' && (chars_allowed & 4)) ||
			(key == ' ' && (chars_allowed & 8)) ||
			(key == '.' && (chars_allowed & 16)) ||
			(key >= 1 && key <= 255 && (chars_allowed == ALLOW_ALL))
			))
		{
			string[i] = key;
			i++;
		}

		if(key == KEY_CTRL_DEL)
		{
			i--;
			string[i] = 0;
			Cursor_SetPosition(column, row);

			for(j = 0; j<string_length; j++)
				Print((const unsigned char*)" ");
		}

		displacement = (i >= input_box_length) ? i - input_box_length : 0;

		if(i < 0) i = 0;
		if(i == string_length) string[i] = 0;
		if(i > string_length) i = string_length;
	}

	Cursor_SetFlashMode(0);
	Cursor_SetFlashStyle(0);

	if(key == KEY_CTRL_EXIT)
		return 0;

	return 1;
}

int EI_str_length(char* str)
{
	int i = 0;

	while(str[i]) i++;
	
	return i;
}
